// EditorView.cpp : implementation file
//

#include "stdafx.h"
#include "trled.h"
#include "TrlEdDoc.h"
#include "EditorView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorView

IMPLEMENT_DYNCREATE(CEditorView, CFormView)

CEditorView::CEditorView()
	: CFormView(CEditorView::IDD)
{
	//{{AFX_DATA_INIT(CEditorView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
    m_nEditMode = EDIT_MODE_SECTORS;
}

CEditorView::~CEditorView()
{
}

void CEditorView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditorView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditorView, CFormView)
	//{{AFX_MSG_MAP(CEditorView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorView diagnostics

#ifdef _DEBUG
void CEditorView::AssertValid() const
{
	CFormView::AssertValid();
}

void CEditorView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CEditorView message handlers

void CEditorView::OnInitialUpdate() 
{
	RECT rect;
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    CFormView::OnInitialUpdate();
    m_nEditMode = pDoc->m_nEditMode;
    GetClientRect(&rect);
    
    m_SectorEditor.m_pDoc = pDoc;
    m_SectorEditor.Create(WS_CHILD, rect, this, ID_SECTOR_EDITOR);
    
    m_RoomEditor.m_pDoc = pDoc;
    m_RoomEditor.Create(WS_CHILD, rect, this, ID_ROOM_EDITOR);
    
    m_ItemEditor.m_pDoc = pDoc;
    m_ItemEditor.Create(WS_CHILD, rect, this, ID_ITEM_EDITOR);
    m_SectorEditor.ShowWindow(SW_SHOW);
}

void CEditorView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
    CTrlEdDoc *pDoc = (CTrlEdDoc *)GetDocument();
    if (!(lHint & UPDATE_VIEW_EDITOR))
    {
        return;
    }
    if (m_nEditMode != pDoc->m_nEditMode)
    {
        Hide(m_nEditMode);
        m_nEditMode = pDoc->m_nEditMode;
        Show(m_nEditMode);
    }
    switch (m_nEditMode)
    {
        case EDIT_MODE_SECTORS:
            m_SectorEditor.m_Page1.UpdateData(FALSE);
            m_SectorEditor.m_Page2.UpdateData(FALSE);
            break;

        case EDIT_MODE_ROOMS:
            m_RoomEditor.m_Page1.UpdateData(FALSE);
            break;

        case EDIT_MODE_ITEMS:
            m_ItemEditor.m_Page1.UpdateData(FALSE);
            break;

        default:
            ASSERT(FALSE);
            break;
    }
}

void CEditorView::Hide(int nView)
{
    int nPage;
    switch (nView)
    {
        case EDIT_MODE_SECTORS:
            nPage = m_SectorEditor.m_nPage;
            if (nPage == 1)
            {
                m_SectorEditor.m_Page1.ShowWindow(SW_HIDE);
            }
            else if (nPage == 2)
            {
                m_SectorEditor.m_Page2.ShowWindow(SW_HIDE);
            }
            m_SectorEditor.ShowWindow(SW_HIDE);
            break;

        case EDIT_MODE_ROOMS:
            nPage = m_RoomEditor.m_nPage;
            if (nPage == 1)
            {
                m_RoomEditor.m_Page1.ShowWindow(SW_HIDE);
            }
            m_RoomEditor.ShowWindow(SW_HIDE);
            break;

        case EDIT_MODE_ITEMS:
            nPage = m_ItemEditor.m_nPage;
            if (nPage == 1)
            {
                m_ItemEditor.m_Page1.ShowWindow(SW_HIDE);
            }
            m_ItemEditor.ShowWindow(SW_HIDE);
            break;

        default:
            ASSERT(FALSE);
            break;
    }
}

void CEditorView::Show(int nView)
{
    int nPage;
    switch (nView)
    {
        case EDIT_MODE_SECTORS:
            m_SectorEditor.ShowWindow(SW_SHOW);
            nPage = m_SectorEditor.m_nPage;
            if (nPage == 1)
            {
                m_SectorEditor.m_Page1.ShowWindow(SW_SHOW);
            }
            else if (nPage == 2)
            {
                m_SectorEditor.m_Page2.ShowWindow(SW_SHOW);
            }
            break;

        case EDIT_MODE_ROOMS:
            m_RoomEditor.ShowWindow(SW_SHOW);
            nPage = m_RoomEditor.m_nPage;
            if (nPage == 1)
            {
                m_RoomEditor.m_Page1.ShowWindow(SW_SHOW);
            }
            break;

        case EDIT_MODE_ITEMS:
            m_ItemEditor.ShowWindow(SW_SHOW);
            nPage = m_ItemEditor.m_nPage;
            if (nPage == 1)
            {
                m_ItemEditor.m_Page1.ShowWindow(SW_SHOW);
            }
            break;

        default:
            ASSERT(FALSE);
            break;
    }
}
