// ObjtexViewer.cpp : implementation file
//

#include "stdafx.h"
#include "TrlEd.h"
#include "TrlEdDoc.h"
#include "TextileViewer.h"
#include "ObjtexViewer.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CObjtexViewer

IMPLEMENT_DYNCREATE(CObjtexViewer, CMDIChildWnd)

CObjtexViewer::CObjtexViewer()
{
    m_nObjtex = 0xcf;
}

CObjtexViewer::~CObjtexViewer()
{
}


BEGIN_MESSAGE_MAP(CObjtexViewer, CMDIChildWnd)
    //{{AFX_MSG_MAP(CObjtexViewer)
    ON_WM_CREATE()
    ON_WM_PAINT()
    ON_WM_DESTROY()
    ON_WM_KEYDOWN()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CObjtexViewer message handlers

BOOL CObjtexViewer::PreCreateWindow(CREATESTRUCT& cs) 
{
    cs.dwExStyle |= WS_EX_TOOLWINDOW;
    return CMDIChildWnd::PreCreateWindow(cs);
}

int CObjtexViewer::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    CTrlEdApp *pApp = (CTrlEdApp *)AfxGetApp();
    CMultiDocTemplate *pDocTemplate;
    CTrlEdDoc *pDoc;
    POSITION pos;
    CDC *pDC;
    BITMAPINFO *pbmi;
    LOGPALETTE *pLogPal;
    u_char *pPalette;
    u_char *pColormap;
    TEXTMETRIC tm;
    int x;
    if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
        return -1;
    if ((pos = pApp->GetFirstDocTemplatePosition()) == NULL)
        ASSERT(FALSE);
    pDocTemplate = (CMultiDocTemplate *)pApp->GetNextDocTemplate(pos);
    pos = pDocTemplate->GetFirstDocPosition();
    pDoc = (CTrlEdDoc *)pDocTemplate->GetNextDoc(pos);
    m_pphd = &pDoc->m_phd;
    //ASSERT(m_pDoc->m_cPHD.m_bPHDIsLoaded == TRUE);
    pPalette = m_pphd->palette;
    pColormap = m_pphd->colormaps[0].colormap;
    pLogPal = (LOGPALETTE *)malloc(4+(256*sizeof(PALETTEENTRY)));
    memset(pLogPal, 0, 4+(256*sizeof(PALETTEENTRY)));
    pLogPal->palVersion = 0x300;
    pLogPal->palNumEntries = 256;
    for (x = 0; x < 256; x++)
    {
        pLogPal->palPalEntry[x].peRed = pPalette[(x*3)+0];
        pLogPal->palPalEntry[x].peGreen = pPalette[(x*3)+1];
        pLogPal->palPalEntry[x].peBlue = pPalette[(x*3)+2];
    }
    if (m_Palette.CreatePalette(pLogPal) == 0)
        ASSERT(FALSE);
    if ((pDC = GetDC()) == NULL)
        ASSERT(FALSE);
    pDC->GetTextMetrics(&tm);
    if (m_BitmapDC.CreateCompatibleDC(pDC) == 0)
        ASSERT(FALSE);
    pbmi = (BITMAPINFO *)malloc(sizeof(BITMAPINFOHEADER)+(256*sizeof(RGBQUAD)));
    memset(pbmi, 0, sizeof(BITMAPINFOHEADER)+(256*sizeof(RGBQUAD)));
    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    pbmi->bmiHeader.biWidth = BITMAP_SIZE_X;
    pbmi->bmiHeader.biHeight = -BITMAP_SIZE_Y;
    pbmi->bmiHeader.biPlanes = 1;
    pbmi->bmiHeader.biBitCount = 8;
    pbmi->bmiHeader.biCompression = BI_RGB;
    for (x = 0; x < 256; x++)
    {
        pbmi->bmiColors[x].rgbRed = pPalette[(pColormap[x]*3)+0];
        pbmi->bmiColors[x].rgbGreen = pPalette[(pColormap[x]*3)+1];
        pbmi->bmiColors[x].rgbBlue = pPalette[(pColormap[x]*3)+2];
    }
    if ((m_hBitmap = CreateDIBSection(m_BitmapDC.m_hDC, pbmi, DIB_RGB_COLORS, (void **)&m_pBitmapBits, NULL, 0)) == NULL)
    {
        DWORD err = GetLastError();
        ASSERT(FALSE);
    }
    if (m_Bitmap.Attach(m_hBitmap) == FALSE)
        ASSERT(FALSE);
    if (m_BitmapDC.SelectObject(&m_Bitmap) == NULL)
        ASSERT(FALSE);
    memset(m_pBitmapBits, 0, 0x10000);
    free(pLogPal);
    free(pbmi);
    ReleaseDC(pDC);
    return 0;
}

void CObjtexViewer::DrawObjtex(int nObjtex)
{
    int c, y, xCenter, yCenter;
    RECT rect;
    u_char *pSrc;
    rect.left = m_pphd->objtextures[nObjtex].ulx;
    rect.top = m_pphd->objtextures[nObjtex].uly;
    rect.right = m_pphd->objtextures[nObjtex].urx;
    rect.bottom = m_pphd->objtextures[nObjtex].lry;
    if (m_pphd->objtextures[nObjtex].ulx < m_pphd->objtextures[nObjtex].urx)
    {
        rect.left = m_pphd->objtextures[nObjtex].ulx;
        rect.right = m_pphd->objtextures[nObjtex].urx;
    }
    else
    {
        rect.left = m_pphd->objtextures[nObjtex].urx;
        rect.right = m_pphd->objtextures[nObjtex].ulx;
    }
    if (m_pphd->objtextures[nObjtex].uly < m_pphd->objtextures[nObjtex].lly)
    {
        rect.top = m_pphd->objtextures[nObjtex].uly;
        rect.bottom = m_pphd->objtextures[nObjtex].lly;
    }
    else
    {
        rect.top = m_pphd->objtextures[nObjtex].lly;
        rect.bottom = m_pphd->objtextures[nObjtex].uly;
    }
    xCenter = (BITMAP_SIZE_X/2)-((rect.right-rect.left)/2);
    yCenter = (BITMAP_SIZE_Y/2)-((rect.bottom-rect.top)/2);
    pSrc = m_pphd->textiles[m_pphd->objtextures[nObjtex].tile].tile;
    memset(m_pBitmapBits, 0, BITMAP_SIZE_X*BITMAP_SIZE_Y);
    for (y = yCenter, c = rect.top; c < rect.bottom; y++, c++)
    {
        memcpy(m_pBitmapBits+(y*BITMAP_SIZE_X)+xCenter, pSrc+(c*256)+rect.left, rect.right-rect.left);
    }
}

void CObjtexViewer::OnPaint() 
{
    CPaintDC DC(this);
    RECT rect;
    CPen pen;
    CPen *pOldPen;
    CPalette *pOldPalette;
    char szTemp[256];
    GetClientRect(&rect);
    if (DC.BitBlt(0, 0, rect.right, rect.bottom, NULL, 0, 0, BLACKNESS) == 0)
    {    
        ASSERT(FALSE);
    }
    pOldPalette = DC.SelectPalette(&m_Palette, FALSE);
    DC.RealizePalette();
    DrawObjtex(m_nObjtex);
    pen.CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
    pOldPen = m_BitmapDC.SelectObject(&pen);
    m_BitmapDC.MoveTo(0, 0);
    m_BitmapDC.LineTo(256, 256);
    m_BitmapDC.MoveTo(0, 256);
    m_BitmapDC.LineTo(256, 0);
    sprintf(szTemp, "%x", m_nObjtex);
    m_BitmapDC.TextOut(0, 0, szTemp, strlen(szTemp));
    DC.BitBlt(((rect.right-rect.left)/2)-(BITMAP_SIZE_X/2), 20, 256, 256, &m_BitmapDC, 0, 0, SRCCOPY);
    m_BitmapDC.SelectObject(pOldPen);
    DC.SelectPalette(pOldPalette, FALSE);
}

void CObjtexViewer::OnDestroy()
{
    CMainFrame *pMainFrame = (CMainFrame *)AfxGetMainWnd();
    CMDIChildWnd::OnDestroy();
    m_Palette.DeleteObject();
    m_Bitmap.DeleteObject();
    m_BitmapDC.DeleteDC();
    pMainFrame->m_pObjtexViewer = NULL;
}

void CObjtexViewer::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
    UINT nScanCode = nFlags & 0xff;
    switch (nScanCode)
    {
        case 0x4b: //left
            if (m_nObjtex > 0)
            {    
                m_nObjtex--;
            }
            break;

        case 0x4d: //right
            if (m_nObjtex < m_pphd->numobjtextures-1)
            {
                m_nObjtex++;
            }
            break;
    }
    Invalidate(FALSE);
    CMDIChildWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
