// SectorEditor.cpp : implementation file
//

#include "stdafx.h"
#include "trled.h"
#include "TrlEdDoc.h"
#include "SectorEditor.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSectorEditor

CSectorEditor::CSectorEditor()
{
    m_nPage = 1;
    m_pDoc = NULL;
}

CSectorEditor::~CSectorEditor()
{
}


BEGIN_MESSAGE_MAP(CSectorEditor, CTabCtrl)
	//{{AFX_MSG_MAP(CSectorEditor)
	ON_NOTIFY_REFLECT(TCN_SELCHANGE, OnSelchange)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSectorEditor message handlers

void CSectorEditor::OnSelchange(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nCurPage;
    *pResult = 0;
    nCurPage = GetCurSel();
    if (nCurPage == -1)
    {
        return;
    }
    nCurPage++;
    switch (m_nPage)
    {
        case 1:
            m_Page1.ShowWindow(SW_HIDE);
            break;

        case 2:
            m_Page2.ShowWindow(SW_HIDE);
            break;

        case 3:
            m_Page3.ShowWindow(SW_HIDE);
            break;

        default:
            ASSERT(FALSE);
            break;
    }
    switch (nCurPage)
    {
        case 1:
            m_Page1.ShowWindow(SW_SHOW);
            break;

        case 2:
            m_Page2.ShowWindow(SW_SHOW);
            break;

        case 3:
            m_Page3.ShowWindow(SW_SHOW);
            break;

        default:
            ASSERT(FALSE);
            break;
    }
    m_nPage = nCurPage;
}

int CSectorEditor::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    TC_ITEM item;
    RECT rect, rect2, rect3;
	if (CTabCtrl::OnCreate(lpCreateStruct) == -1)
    {
		return -1;
    }
    m_Page1.m_pDoc = m_pDoc;
    m_Page1.Create(CSectorEditorPage1::IDD, this);
    m_Page1.ShowWindow(SW_HIDE);
    m_Page2.m_pDoc = m_pDoc;
    m_Page2.Create(CSectorEditorPage2::IDD, this);
    m_Page2.ShowWindow(SW_HIDE);
    m_Page3.m_pDoc = m_pDoc;
    m_Page3.Create(CSectorEditorPage3::IDD, this);
    m_Page3.ShowWindow(SW_HIDE);
    item.mask = TCIF_TEXT;
    item.pszText = "Page 1";
    InsertItem(0, &item);
    item.pszText = "Page 2";
    InsertItem(1, &item);
    item.pszText = "Page 3";
    InsertItem(2, &item);
    GetItemRect(0, &rect2);
    GetClientRect(&rect3);
    rect.left = rect3.left+5;
    rect.top = rect2.bottom+5;
    rect.right = rect3.right-rect.left-5;
    rect.bottom = rect3.bottom-rect.top-5;
    m_Page1.SetWindowPos(&wndTop, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, 0);
    m_Page2.SetWindowPos(&wndTop, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, 0);
    m_Page3.SetWindowPos(&wndTop, rect.left, rect.top, rect.right-rect.left, rect.bottom-rect.top, 0);
    m_Page1.ShowWindow(SW_SHOW);
	return 0;
}
