#if !defined(AFX_SECTORVIEW_H__A3579182_89EB_11D1_8C74_D056CB8E3C60__INCLUDED_)
#define AFX_SECTORVIEW_H__A3579182_89EB_11D1_8C74_D056CB8E3C60__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SectorView.h : header file
//

#define ZOOM_STEP 8
#define MOVE_STEP 32

#define VIEW_XZ 0
#define VIEW_YZ 1
#define VIEW_XY 2

#define RED_D       0x01010101
#define RED_W       0x0101
#define RED_B       0x01
#define BLUE_D      0x02020202
#define BLUE_W      0x0202
#define BLUE_B      0x02
#define WHITE_D     0xffffffff
#define WHITE_W     0xffff
#define WHITE_B     0xff

class CSectorView : public CView
{
protected:
	CSectorView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CSectorView)

// Attributes
public:
    CPen m_WhitePen;
    CPen m_WallPen;
    CPen m_NormalPen;
    CPen m_SelectPen;
    CPen m_YellowPen;
    CPen m_BluePen;

    CDC m_BitmapDC;
    CBitmap m_Bitmap;
    HBITMAP m_hBitmap;
    BITMAPINFO *m_pbmi;
    BYTE *m_pBitmapBits;

    int m_nBitmapWidth;
    int m_nBitmapHeight;

    int m_xPos;
    int m_yPos;
    BYTE m_nZoom;
    
    int m_nEditMode;

    void ZoomIn(void);
    void ZoomOut(void);

    void DrawRectangle(int x1, int y1, int x2, int y2);
    void DrawRooms(void);
    void DrawRooms_asm(void);
    void DrawRooms_asm2(void);

    void OnUpdate_SECTORS(void);
    void OnUpdate_ROOMS(void);
    void OnUpdate_ITEMS(void);

    void OnLButtonDown_SECTORS(UINT nFlags, CPoint *point);
    void OnLButtonDown_ROOMS(UINT nFlags, CPoint *point);
    void OnLButtonDown_ITEMS(UINT nFlags, CPoint *point);

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSectorView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CSectorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CSectorView)
	afx_msg void OnDestroy();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SECTORVIEW_H__A3579182_89EB_11D1_8C74_D056CB8E3C60__INCLUDED_)
