`// TextileViewer.cpp : implementation file
//

#include "stdafx.h"
#include "TrlEd.h"
#include "TrlEdDoc.h"
#include "TextileViewer.h"
#include "ObjtexViewer.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTextileViewer

IMPLEMENT_DYNCREATE(CTextileViewer, CMDIChildWnd)

CTextileViewer::CTextileViewer()
{
}

CTextileViewer::~CTextileViewer()
{
}


BEGIN_MESSAGE_MAP(CTextileViewer, CMDIChildWnd)
    //{{AFX_MSG_MAP(CTextileViewer)
    ON_WM_CREATE()
    ON_WM_PAINT()
    ON_WM_CTLCOLOR()
    ON_WM_DESTROY()
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextileViewer message handlers

BOOL CTextileViewer::PreCreateWindow(CREATESTRUCT& cs) 
{
    cs.dwExStyle |= WS_EX_TOOLWINDOW;
    return CMDIChildWnd::PreCreateWindow(cs);
}

int CTextileViewer::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
    CTrlEdApp *pApp = (CTrlEdApp *)AfxGetApp();
    CMultiDocTemplate *pDocTemplate;
    CTrlEdDoc *pDoc;
    POSITION pos;
    CDC *pDC;
    BITMAPINFO *pbmi;
    LOGPALETTE *pLogPal;
    BYTE *pPalette;
    u_char *pColormap;
    RECT rect;
    LOGBRUSH lb;
    TEXTMETRIC tm;
    UDACCEL uda;
    int x;
    if (CMDIChildWnd::OnCreate(lpCreateStruct) == -1)
        return -1;
    if ((pos = pApp->GetFirstDocTemplatePosition()) == NULL)
        ASSERT(FALSE);
    pDocTemplate = (CMultiDocTemplate *)pApp->GetNextDocTemplate(pos);
    pos = pDocTemplate->GetFirstDocPosition();
    pDoc = (CTrlEdDoc *)pDocTemplate->GetNextDoc(pos);
    m_pphd = &pDoc->m_phd;
    //ASSERT(m_pDoc->m_cPHD.m_bPHDIsLoaded == TRUE);
    pPalette = m_pphd->palette;
    pColormap = m_pphd->colormaps[0].colormap;
    pLogPal = (LOGPALETTE *)malloc(4+(256*sizeof(PALETTEENTRY)));
    memset(pLogPal, 0, 4+(256*sizeof(PALETTEENTRY)));
    pLogPal->palVersion = 0x300;
    pLogPal->palNumEntries = 256;
    for (x = 0; x < 256; x++)
    {
        pLogPal->palPalEntry[x].peRed = pPalette[(x*3)+0];
        pLogPal->palPalEntry[x].peGreen = pPalette[(x*3)+1];
        pLogPal->palPalEntry[x].peBlue = pPalette[(x*3)+2];
    }
    if (m_Palette.CreatePalette(pLogPal) == 0)
        ASSERT(FALSE);
    if ((pDC = GetDC()) == NULL)
        ASSERT(FALSE);
    pDC->GetTextMetrics(&tm);
    if (m_BitmapDC.CreateCompatibleDC(pDC) == 0)
        ASSERT(FALSE);
    pbmi = (BITMAPINFO *)malloc(sizeof(BITMAPINFOHEADER)+(256*sizeof(RGBQUAD)));
    memset(pbmi, 0, sizeof(BITMAPINFOHEADER)+(256*sizeof(RGBQUAD)));
    pbmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
    pbmi->bmiHeader.biWidth = 256;
    pbmi->bmiHeader.biHeight = -256;
    pbmi->bmiHeader.biPlanes = 1;
    pbmi->bmiHeader.biBitCount = 8;
    pbmi->bmiHeader.biCompression = BI_RGB;
    for (x = 0; x < 256; x++)
    {
        pbmi->bmiColors[x].rgbRed = pPalette[(pColormap[x]*3)+0];
        pbmi->bmiColors[x].rgbGreen = pPalette[(pColormap[x]*3)+1];
        pbmi->bmiColors[x].rgbBlue = pPalette[(pColormap[x]*3)+2];
    }
    if ((m_hBitmap = CreateDIBSection(m_BitmapDC.m_hDC, pbmi, DIB_RGB_COLORS, (void **)&m_pBitmapBits, NULL, 0)) == NULL)
    {
        DWORD err = GetLastError();
        ASSERT(FALSE);
    }
    if (m_Bitmap.Attach(m_hBitmap) == FALSE)
        ASSERT(FALSE);
    if (m_BitmapDC.SelectObject(&m_Bitmap) == NULL)
        ASSERT(FALSE);
    memcpy(m_pBitmapBits, m_pphd->textiles, 0x10000);
    free(pLogPal);
    free(pbmi);
    ReleaseDC(pDC);
    
    lb.lbStyle = BS_SOLID;
    lb.lbColor = RGB(0, 0, 0);
    lb.lbHatch = 0;
    m_hBrush = CreateBrushIndirect(&lb);

    uda.nSec = 1;
    uda.nInc = 1;

    rect.left = 20+(4*tm.tmAveCharWidth);
    rect.top = 256+35;
    rect.right = rect.left+25;
    rect.bottom = rect.top+20;
    m_TextileSpinBuddy.Create(NULL, WS_CHILD|WS_VISIBLE, rect, this);
    rect.left = 20+(4*tm.tmAveCharWidth)+30;
    rect.top = 256+38;
    rect.right = rect.left+30;
    rect.bottom = rect.top+15;
    m_TextileSpin.Create(WS_CHILD|WS_VISIBLE|UDS_SETBUDDYINT|UDS_HORZ, rect, this, IDC_TEXTILE_SPIN);
    m_TextileSpin.SetBuddy(&m_TextileSpinBuddy);
    m_TextileSpin.SetRange(0, m_pphd->numtextiles-1);
    m_TextileSpin.SetPos(0);
    m_TextileSpin.SetAccel(1, &uda);

    rect.left = 140+(8*tm.tmAveCharWidth)+10;
    rect.top = 256+35;
    rect.right = rect.left+25;
    rect.bottom = rect.top+20;
    m_ColormapSpinBuddy.Create(NULL, WS_CHILD|WS_VISIBLE, rect, this);
    rect.left = 140+(8*tm.tmAveCharWidth)+40;
    rect.top = 256+38;
    rect.right = rect.left+30;
    rect.bottom = rect.top+15;
    m_ColormapSpin.Create(WS_CHILD|WS_VISIBLE|UDS_SETBUDDYINT|UDS_HORZ, rect, this, IDC_COLORMAP_SPIN);
    m_ColormapSpin.SetBuddy(&m_ColormapSpinBuddy);
    m_ColormapSpin.SetRange(0, PHD_NUMCOLORMAPS-1);
    m_ColormapSpin.SetPos(0);
    m_ColormapSpin.SetAccel(1, &uda);
    return 0;
}

void CTextileViewer::OnPaint() 
{
    CPaintDC DC(this);
    CPalette *pOldPal;
    RECT rect;
    RGBQUAD rgbPal[256];
    static int nLastTile = 0;
    static int nLastColormap = 0;
    int x, nThisTile, nThisColormap;
    u_char *pPalette;
    u_char *pColormap;
    nThisTile = m_TextileSpin.GetPos();
    if (nLastTile != nThisTile)
    {
        memcpy(m_pBitmapBits, m_pphd->textiles[nThisTile].tile, 0x10000);
        nLastTile = nThisTile;
    }
    nThisColormap = m_ColormapSpin.GetPos();
    if (nLastColormap != nThisColormap)
    {
        pPalette = m_pphd->palette;
        pColormap = m_pphd->colormaps[nThisColormap].colormap;
        for (x = 0; x < 256; x++)
        {
            rgbPal[x].rgbRed = pPalette[(pColormap[x]*3)+0];
            rgbPal[x].rgbGreen = pPalette[(pColormap[x]*3)+1];
            rgbPal[x].rgbBlue = pPalette[(pColormap[x]*3)+2];
            rgbPal[x].rgbReserved = 0;
        }
        SetDIBColorTable(m_BitmapDC.m_hDC, 0, 256, rgbPal);
        nLastColormap = nThisColormap;
    }
    GetClientRect(&rect);
    if (DC.BitBlt(0, 0, rect.right, rect.bottom, NULL, 0, 0, BLACKNESS) == 0)
        ASSERT(FALSE);
    if ((pOldPal = DC.SelectPalette(&m_Palette, TRUE)) == NULL)
        ASSERT(FALSE);
    DC.RealizePalette();
    if (DC.BitBlt(20, 20, 256, 256, &m_BitmapDC, 0, 0, SRCCOPY) == 0)
        ASSERT(FALSE);
    DC.SelectPalette(pOldPal, FALSE);
    DC.RealizePalette();
    DC.SetBkColor(RGB(0, 0, 0));
    DC.SetTextColor(RGB(255, 255, 255));
    DC.TextOut(20, 256+35, "Tile", 4);
    DC.TextOut(140, 256+35, "Colormap", 8);
}

BOOL CTextileViewer::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
    if (wParam == IDC_TEXTILE_SPIN)
    {
        Invalidate(FALSE);
    }
    if (wParam == IDC_COLORMAP_SPIN)
    {
        Invalidate(FALSE);
    }
    return CMDIChildWnd::OnNotify(wParam, lParam, pResult);
}

HBRUSH CTextileViewer::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
    HBRUSH hbr = CMDIChildWnd::OnCtlColor(pDC, pWnd, nCtlColor);
    pDC->SetBkColor(RGB(0, 0, 0));
    pDC->SetTextColor(RGB(255, 255, 255));
    return m_hBrush;
}

void CTextileViewer::OnDestroy() 
{
    CMainFrame *pMainFrame = (CMainFrame *)AfxGetMainWnd();
    CMDIChildWnd::OnDestroy();
    m_Palette.DeleteObject();
    m_Bitmap.DeleteObject();
    m_BitmapDC.DeleteDC();
    DeleteObject(m_hBrush);
    pMainFrame->m_pTextileViewer = NULL;
}
