// TrlEdDoc.cpp : implementation of the CTrlEdDoc class
//

#include "stdafx.h"
#include "TrlEd.h"
#include "MyMemory.h"
#include "TrlEdDoc.h"
#include "TextileViewer.h"
#include "ObjtexViewer.h"
#include "MainFrm.h"
#include "room.h"
#include "MainView.h"
#include "SectorEditor.h"
#include "ChildFrm.h"
#include "trl.h"
#include "trm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTrlEdDoc

IMPLEMENT_DYNCREATE(CTrlEdDoc, CDocument)

BEGIN_MESSAGE_MAP(CTrlEdDoc, CDocument)
    //{{AFX_MSG_MAP(CTrlEdDoc)
    ON_COMMAND(ID_VIEW_TEXTURETILES, OnViewTexturetiles)
    ON_COMMAND(ID_VIEW_OBJTEXTURES, OnViewObjtextures)
    ON_COMMAND(ID_BUILD_TRL, OnBuildTrl)
    ON_COMMAND(ID_NEW_ROOM, OnNewRoom)
    ON_COMMAND(ID_SECTOR_MODE, OnSectorMode)
    ON_COMMAND(ID_ROOM_MODE, OnRoomMode)
    ON_COMMAND(ID_ITEM_MODE, OnItemMode)
    ON_UPDATE_COMMAND_UI(ID_ITEM_MODE, OnUpdateItemMode)
    ON_UPDATE_COMMAND_UI(ID_SECTOR_MODE, OnUpdateSectorMode)
    ON_UPDATE_COMMAND_UI(ID_ROOM_MODE, OnUpdateRoomMode)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrlEdDoc construction/destruction

CTrlEdDoc::CTrlEdDoc()
{
    m_pChildFrame = NULL;
    m_pMainView = NULL;
    m_pSectorView = NULL;
    m_pEditorView = NULL;
    m_bKeyDown = FALSE;
    m_nEditMode = EDIT_MODE_SECTORS;
    m_pItem = NULL;
}

CTrlEdDoc::~CTrlEdDoc()
{
}

/////////////////////////////////////////////////////////////////////////////
// CTrlEdDoc serialization

void CTrlEdDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring())
    {
    }
    else
    {
    }
}

/////////////////////////////////////////////////////////////////////////////
// CTrlEdDoc diagnostics

#ifdef _DEBUG
void CTrlEdDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CTrlEdDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTrlEdDoc commands

BOOL CTrlEdDoc::OnNewDocument() 
{
    TCHAR szTemp[256];
    CTrlEdApp *pApp = (CTrlEdApp *)AfxGetApp();

    pApp->m_pDoc = this;

    memset(&m_trm, 0, sizeof(trm_t));
    m_nSector = 0;
    m_nRoom = 0;

    memcpy(m_trm.header.magic, TRM_MAGIC, lstrlen(TRM_MAGIC));
    m_trm.header.trmversion = TRM_VERSION;
    m_trm.header.gameversion = TR2_VERSION;
    lstrcpy(szTemp, "wall.tr2");
    memcpy(m_trm.header.baselevel, szTemp, lstrlen(szTemp));
    lstrcpy(szTemp, "test level 1");
    memcpy(m_trm.header.levelname, szTemp, lstrlen(szTemp));

    NewLevel(&m_trm);
    m_nRoom = 1;
    
    //SetModifiedFlag(TRUE);
    return TRUE;
}

BOOL CTrlEdDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
    CTrlEdApp *pApp = (CTrlEdApp *)AfxGetApp();
    if (!CDocument::OnOpenDocument(lpszPathName))
    {
        return FALSE;
    }

    pApp->m_pDoc = this;

    FreeAllBlocks();
    memset(&m_trm, 0, sizeof(trm_t));
    m_nSector = 0;
    m_nRoom = 0;

    LoadTrmFile((char *)lpszPathName, &m_trm);
    return TRUE;
}

BOOL CTrlEdDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
    BuildTrmFile((char *)lpszPathName, &m_trm);
    SetModifiedFlag(FALSE);
    return TRUE;
}

void CTrlEdDoc::OnCloseDocument() 
{
    CTrlEdApp *pApp = (CTrlEdApp *)AfxGetApp();

    pApp->m_pDoc = NULL;
    m_pSectorView = NULL;
    m_pMainView = NULL;
    
    CDocument::OnCloseDocument();
    /*CMainFrame *pMainFrame = (CMainFrame *)AfxGetMainWnd();
    CMDIChildWnd *pChildWnd;
    CDocument::OnCloseDocument();
    pChildWnd = pMainFrame->MDIGetActive();
    while (pChildWnd != NULL)
    {
        pChildWnd->MDIDestroy();
        pChildWnd = pMainFrame->MDIGetActive();
    }
    pMainFrame->SetWindowText("TrlEd");
    CToolBarCtrl &tb = pMainFrame->m_wndToolBar.GetToolBarCtrl();
    tb.HideButton(ID_FILE_SAVE, TRUE);
    tb.HideButton(ID_VIEW_TEXTURETILES, TRUE);
    tb.HideButton(ID_VIEW_OBJTEXTURES, TRUE);
    tb.HideButton(ID_XZ_VIEW, TRUE);
    tb.HideButton(ID_XY_VIEW, TRUE);
    tb.HideButton(ID_YZ_VIEW, TRUE);*/
}

void CTrlEdDoc::OnViewTexturetiles() 
{
    /*RECT rect;
    if (m_pObjtexViewer != NULL)
    {
        MDIActivate(m_pObjtexViewer);
        return;
    }
    rect.left = 0;
    rect.top = 0;
    rect.right = OBJTEXVIEWER_SIZE_X;
    rect.bottom = OBJTEXVIEWER_SIZE_Y;
    m_pObjtexViewer = new CObjtexViewer;
    m_pObjtexViewer->Create(AfxRegisterWndClass(0), "Object Texture Viewer", WS_CHILD|WS_VISIBLE|WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU, rect, NULL, NULL);*/
}

void CTrlEdDoc::OnViewObjtextures() 
{
    /*RECT rect;
    if (m_pTextileViewer != NULL)
    {
        MDIActivate(m_pTextileViewer);
        return;
    }
    rect.left = 0;
    rect.top = 0;
    rect.right = TEXTILEVIEWER_SIZE_X;
    rect.bottom = TEXTILEVIEWER_SIZE_Y;
    m_pTextileViewer = new CTextileViewer;
    m_pTextileViewer->Create(AfxRegisterWndClass(0), "Texture Tile Viewer", WS_CHILD|WS_VISIBLE|WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU, rect, NULL, NULL);*/
}

void CTrlEdDoc::OnBuildTrl() 
{
    BuildTrlFile("c:\\trled1.trl", &m_trm);
}

void CTrlEdDoc::OnNewRoom() 
{
    trm_room_t *room;
    room = NewRoom(&m_trm, 11, 12);
    m_nRoom++;
    DoTitle();
    UpdateAllViews(NULL, UPDATE_VIEW_SECTORS|UPDATE_VIEW_EDITOR);
}

void CTrlEdDoc::OnKeyDown(HWND hWnd, WPARAM wParam, LPARAM lParam)
{
    UINT nScanCode = (lParam >> 16) & 0xff;
    m_bKeyDown = TRUE;
    switch (nScanCode)
    {
        case 0x34: //>
            NextRoom();
            break;
            
        case 0x33: //<
            PrevRoom();
            break;
        
        default:
            if (m_pSectorView)
            {
                m_pSectorView->SendMessage(WM_KEYDOWN, wParam, lParam);
            }
            if (m_pMainView)
            {
                m_pMainView->SendMessage(WM_KEYDOWN, wParam, lParam);
            }
            break;
    }
    m_bKeyDown = FALSE;
}

void CTrlEdDoc::DoTitle(void)
{
    TCHAR szTemp[256];
    wsprintf(szTemp, "room %d", m_nRoom);
    m_pChildFrame->SetWindowText(szTemp);
}

void CTrlEdDoc::OnSectorMode() 
{
    if (m_nEditMode != EDIT_MODE_SECTORS)
    {
        m_nEditMode = EDIT_MODE_SECTORS;
        m_nSector = 0;
        UpdateAllViews(NULL, UPDATE_VIEW_MAIN|UPDATE_VIEW_SECTORS|UPDATE_VIEW_EDITOR);
    }
}

void CTrlEdDoc::OnRoomMode() 
{
    if (m_nEditMode != EDIT_MODE_ROOMS)
    {
        m_nEditMode = EDIT_MODE_ROOMS;
        UpdateAllViews(NULL, UPDATE_VIEW_MAIN|UPDATE_VIEW_SECTORS|UPDATE_VIEW_EDITOR);
    }
}

void CTrlEdDoc::OnItemMode() 
{
    if (m_nEditMode != EDIT_MODE_ITEMS)
    {
        m_nEditMode = EDIT_MODE_ITEMS;
        UpdateAllViews(NULL, UPDATE_VIEW_MAIN|UPDATE_VIEW_SECTORS|UPDATE_VIEW_EDITOR);
    }
}

void CTrlEdDoc::OnUpdateSectorMode(CCmdUI* pCmdUI) 
{
    if (m_nEditMode == EDIT_MODE_SECTORS)
    {
        pCmdUI->SetCheck(1);
    }
    else
    {
        pCmdUI->SetCheck(0);
    }
}

void CTrlEdDoc::OnUpdateRoomMode(CCmdUI* pCmdUI) 
{
    if (m_nEditMode == EDIT_MODE_ROOMS)
    {
        pCmdUI->SetCheck(1);
    }
    else
    {
        pCmdUI->SetCheck(0);
    }
}

void CTrlEdDoc::OnUpdateItemMode(CCmdUI* pCmdUI) 
{
    if (m_nEditMode == EDIT_MODE_ITEMS)
    {
        pCmdUI->SetCheck(1);
    }
    else
    {
        pCmdUI->SetCheck(0);
    }
}

void CTrlEdDoc::NextRoom(void)
{
    if (m_nRoom < m_trm.numrooms-1)
    {
        m_nRoom++;
        m_trm.roomcurrent = m_trm.roomcurrent->next;
        UpdateAllViews(NULL, UPDATE_VIEW_SECTORS|UPDATE_VIEW_EDITOR);
    }
}

void CTrlEdDoc::PrevRoom(void)
{
    if (m_nRoom > 0)
    {
        m_nRoom--;
        m_trm.roomcurrent = m_trm.roomcurrent->prev;
        UpdateAllViews(NULL, UPDATE_VIEW_SECTORS|UPDATE_VIEW_EDITOR);
    }
}
