//trm.c

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdio.h>
#include <string.h>
#include <crtdbg.h>
#include "types.h"
#include "trmdefs.h"
#include "MyMemory.h"
#include "room.h"
#include "roommesh.h"
#include "linklist.h"
#include "items.h"

#define ASSERT(e) _ASSERT(e)

long NewLevel(trm_t *trm)
{
    item2_t item;
    roomdoor_t *door;
    trm_room_t *room;
    int x = 0x400, y = 0, z = 0x400;
    room = NewRoom(trm, 5, 4);
    
    room->sectors[(4*4)+1].floor = 0;
    room->sectors[(4*4)+1].ceiling = -8;
    room->sectors[(4*4)+1].doorroom = 1;
    
    room->sectors[(4*4)+2].floor = 0;
    room->sectors[(4*4)+2].ceiling = -8;
    room->sectors[(4*4)+2].doorroom = 1;
    
    BuildRoomMesh(room);
    
    room->numdoors = 1;
    door = room->doors = (roomdoor_t *)malloc(sizeof(roomdoor_t));
    memset(door, 0, sizeof(roomdoor_t));
    door->room = 1;
    door->normal.x = -1;
    
    door->vertices[0].x = 0x400*4;
    door->vertices[0].y = 0;
    door->vertices[0].z = 0x400;

    door->vertices[1].x = 0x400*4;
    door->vertices[1].y = -0x800;
    door->vertices[1].z = 0x400;

    door->vertices[2].x = 0x400*4;
    door->vertices[2].y = -0x800;
    door->vertices[2].z = 0x400*3;

    door->vertices[3].x = 0x400*4;
    door->vertices[3].y = 0;
    door->vertices[3].z = 0x400*3;

    room = NewRoom(trm, 5, 4);

    room->sectors[1].floor = 0;
    room->sectors[1].ceiling = -8;
    room->sectors[1].doorroom = 0;

    room->sectors[2].floor = 0;
    room->sectors[2].ceiling = -8;
    room->sectors[2].doorroom = 0;

    BuildRoomMesh(room);
    
    room->numdoors = 1;
    door = room->doors = (roomdoor_t *)malloc(sizeof(roomdoor_t));
    memset(door, 0, sizeof(roomdoor_t));
    door->room = 0;
    door->normal.x = 1;
    x = 0x400, y = 0, z = 0x400;

    door->vertices[0].x = 0x400;
    door->vertices[0].y = 0;
    door->vertices[0].z = 0x400;

    door->vertices[1].x = 0x400;
    door->vertices[1].y = -0x800;
    door->vertices[1].z = 0x400;

    door->vertices[2].x = 0x400;
    door->vertices[2].y = -0x800;
    door->vertices[2].z = 0x400*3;

    door->vertices[3].x = 0x400;
    door->vertices[3].y = 0;
    door->vertices[3].z = 0x400*3;

    room->roominfo.x = (3*0x400);

    memset(&item, 0, sizeof(item2_t));
    item.object = 0; //lara
    item.room = 0;
    item.x = 0x600;
    item.z = 0x600;
    item.un2 = -1;
    NewItem(trm, &item);
    /*item.object = 1;
    item.z = 0xa00;
    NewItem(trm, &item);*/
    return TRUE;
}

//fixme: incomplete: doesn't save all rooms, items
long BuildTrmFile(char *lpszFileName, trm_t *trm)
{
#if 0
    FILE *f;
    trm_room_t *room;
    trm_roomlist_t *r;
    int x, num;
    short s;
    f = fopen(lpszFileName, "wb");
    fwrite(&trm->header, sizeof(trm_header_t), 1, f);
    fwrite(&trm->numtextiles, 4, 1, f);
    ASSERT(!trm->numtextiles);
    fwrite(&trm->numrooms, 2, 1, f);
    ASSERT(trm->numrooms == 1);
    r = trm->roomlisthead;
    for (x = 0; x < trm->numrooms; x++)
    {
        room = r->room;
        fwrite(&room->roominfo, sizeof(roominfo_t), 1, f);
        fwrite(&room->nummeshwords, 4, 1, f);
        ASSERT(room->nummeshwords);
        fwrite(&room->mesh.numvertices, 2, 1, f);
        if (room->mesh.numvertices)
        {    
            fwrite(room->mesh.vertices, sizeof(rmvertex2_t), room->mesh.numvertices, f);
        }
        fwrite(&room->mesh.numpoly4s, 2, 1, f);
        if (room->mesh.numpoly4s)
        {    
            fwrite(room->mesh.poly4s, sizeof(poly4_t), room->mesh.numpoly4s, f);
        }
        fwrite(&room->mesh.numpoly3s, 2, 1, f);
        if (room->mesh.numpoly3s)
        {    
            fwrite(room->mesh.poly3s, sizeof(poly3_t), room->mesh.numpoly3s, f);
        }
        fwrite(&room->mesh.un1, 2, 1, f);

        fwrite(&room->numdoors, 2, 1, f);
        ASSERT(!room->numdoors);
        fwrite(&room->numysectors, 2, 1, f);
        fwrite(&room->numxsectors, 2, 1, f);
        num = room->numxsectors*room->numysectors;
        ASSERT(num);
        fwrite(room->sectors, sizeof(trm_sector_t), num, f);
        fwrite(&room->un1, 1, 1, f);
        fwrite(&room->lightlevel1, 1, 1, f);
        fwrite(&room->un4, 1, 1, f);
        fwrite(&room->lightlevel2, 1, 1, f);
        s = 0;
        fwrite(&s, 2, 1, f);
        fwrite(&s, 2, 1, f);
        fwrite(&s, 2, 1, f);
        fwrite(&room->un2, 2, 1, f);
        fwrite(&room->water, 1, 1, f);
        fwrite(&room->un3, 1, 1, f);
    }
    fwrite(&trm->numitems, 4, 1, f);
    if (trm->numitems)
    {    
        fwrite(trm->items, sizeof(item2_t), trm->numitems, f);
    }
    fclose(f);
#endif
    return TRUE;
}

//fixme: incomplete
long LoadTrmFile(char *lpszFileName, trm_t *trm)
{
#if 0
    FILE *f;
    trm_room_t *room;
    trm_roomlist_t *r;
    unsigned char *p;
    int x, num;
    long pos;
    short s;
    f = fopen(lpszFileName, "rb");
    fread(&trm->header, sizeof(trm_header_t), 1, f);
    pos = ftell(f);
    fread(&trm->numtextiles, 4, 1, f);
    pos = ftell(f);
    ASSERT(!trm->numtextiles);
    fread(&trm->numrooms, 2, 1, f);
    pos = ftell(f);
    ASSERT(trm->numrooms == 1);
    if (trm->numrooms)
    {    
        room = trm->roomlisthead = (trm_roomlist_t *)GetMemBlock(trm->numrooms*sizeof(trm_roomlist_t));
    }
    pos = ftell(f);
    for (x = 0; x < trm->numrooms; x++)
    {
        fread(&room->roominfo, sizeof(roominfo_t), 1, f);
        fread(&room->nummeshwords, 4, 1, f);
        ASSERT(room->nummeshwords);
        if (room->nummeshwords)
        {
            p = room->meshwords = (u_char *)GetMemBlock(room->nummeshwords*2);
            fread(room->meshwords, room->nummeshwords, 2, f);
        }
        room->mesh.numvertices = *(short *)p;
        p += 2;
        if (room->mesh.numvertices)
            room->mesh.vertices = (rmvertex2_t *)p;
        p += room->mesh.numvertices*sizeof(rmvertex2_t);
        room->mesh.numpoly4s = *(short *)p;
        p += 2;
        if (room->mesh.numpoly4s)
            room->mesh.poly4s = (poly4_t *)p;
        p += room->mesh.numpoly4s*sizeof(poly4_t);
        room->mesh.numpoly3s = *(short *)p;
        p += 2;
        if (room->mesh.numpoly3s)
            room->mesh.poly3s = (poly3_t *)p;
        p += room->mesh.numpoly3s*sizeof(poly3_t);
        room->mesh.un1 = *(short *)p;
        p += 2;

        fread(&room->numdoors, 2, 1, f);
        ASSERT(!room->numdoors);
        fread(&room->numysectors, 2, 1, f);
        fread(&room->numxsectors, 2, 1, f);
        num = room->numxsectors*room->numysectors;
        ASSERT(num);
        if (num)
        {
            room->sectors = (trm_sector_t *)GetMemBlock(num*sizeof(trm_sector_t));
            fread(room->sectors, sizeof(trm_sector_t), num, f);
        }
        fread(&room->un1, 1, 1, f);
        fread(&room->lightlevel1, 1, 1, f);
        fread(&room->un4, 1, 1, f);
        fread(&room->lightlevel2, 1, 1, f);
        s = 0;
        fread(&s, 2, 1, f);
        fread(&s, 2, 1, f);
        fread(&s, 2, 1, f);
        fread(&room->un2, 2, 1, f);
        fread(&room->water, 1, 1, f);
        fread(&room->un3, 1, 1, f);
    }
    fread(&trm->numitems, 4, 1, f);
    ASSERT(trm->numitems == 1);
    if (trm->numitems)
    {
        trm->items = (item2_t *)GetMemBlock(trm->numitems*sizeof(item2_t));
        fread(trm->items, sizeof(item2_t), trm->numitems, f);
    }
    fclose(f);
#endif
    return TRUE;
}

#ifdef __cplusplus
}
#endif
