// TrlFeView.cpp : implementation file
//

#include "stdafx.h"
#include "trlfe.h"
#include "TrlFeView.h"
#include "TrlFeDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTrlFeView

IMPLEMENT_DYNCREATE(CTrlFeView, CTreeView)

CTrlFeView::CTrlFeView()
{
}

CTrlFeView::~CTrlFeView()
{
}


BEGIN_MESSAGE_MAP(CTrlFeView, CTreeView)
	//{{AFX_MSG_MAP(CTrlFeView)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, OnItemexpanding)
	ON_NOTIFY_REFLECT(TVN_SELCHANGING, OnSelchanging)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTrlFeView diagnostics

#ifdef _DEBUG
void CTrlFeView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CTrlFeView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTrlFeView message handlers

void CTrlFeView::OnInitialUpdate() 
{
	TCHAR szDrives[512];
    TV_INSERTSTRUCT tvis;
    CTreeCtrl& tc = GetTreeCtrl();
    HTREEITEM hItem;
    LPTSTR lpszSrc, lpszLast;
    DWORD dwDrives;
    int x;
    CTreeView::OnInitialUpdate();
    memset(&tvis, 0, sizeof(TV_INSERTSTRUCT));
    tvis.hParent = TVI_ROOT;
    tvis.hInsertAfter = TVI_LAST;
    tvis.item.mask = TVIF_TEXT|TVIF_CHILDREN;
    tvis.item.cChildren = 1;
    dwDrives = GetLogicalDriveStrings(sizeof(szDrives), szDrives);
    lpszSrc = lpszLast = szDrives;
    while (1)
    {
        if (*lpszSrc++ == 0)
        {
            tvis.item.pszText = lpszLast;
            if (lpszLast[0] != 0)
                hItem = tc.InsertItem(&tvis);
            if (lstrcmpi(lpszLast, "c:\\") == 0)
                tc.SelectItem(hItem);
            if (*lpszSrc == 0)
            {
                break;
            }
            lpszLast = lpszSrc;
        }
    }
}

BOOL CTrlFeView::PreCreateWindow(CREATESTRUCT& cs) 
{
    cs.style |= TVS_HASLINES|TVS_HASBUTTONS|TVS_LINESATROOT;
	return CTreeView::PreCreateWindow(cs);
}

void CTrlFeView::GetPathFromItem(HTREEITEM hSrcItem, LPTSTR lpszPath)
{
    CString cs;
	TCHAR szPath[MAX_PATH];
    CTreeCtrl& tc = GetTreeCtrl();
    HTREEITEM hItem;
    LPTSTR lpszSrc, lpsz;
    hItem = hSrcItem;
    szPath[0] = 0;
    while (1)
    {
        cs = tc.GetItemText(hItem);
        lstrcat(szPath, "\\");
        lstrcat(szPath, (LPCTSTR)cs);
        hItem = tc.GetParentItem(hItem);
        if (!hItem)
            break;
    }
    szPath[lstrlen(szPath)-1] = 0;
    lpszPath[0] = 0;
    lpszSrc = szPath;
    while (1)
    {
        lpsz = strrchr(szPath, '\\');
        if (!lpsz)
            break;
        *lpsz = 0;
        lpsz++;
        lstrcat(lpszPath, lpsz);
        lstrcat(lpszPath, "\\");
    }
    if (lpszPath[lstrlen(lpszPath)-1] == '\\')
        lpszPath[lstrlen(lpszPath)-1] = 0;
    cs.Empty();
}

BOOL HasSubDirs(LPTSTR lpszPath)
{
    TCHAR szPath[MAX_PATH];
    WIN32_FIND_DATA fd;
    HANDLE hFile;
    wsprintf(szPath, "%s\\*.*", lpszPath);
    hFile = FindFirstFile(szPath, &fd);
    if (hFile == INVALID_HANDLE_VALUE)
        return FALSE;
    while(1)
    {
        if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
        {
            if ((lstrcmp(fd.cFileName, ".") != 0) && (lstrcmp(fd.cFileName, "..") != 0))
            {
                FindClose(hFile);
                return TRUE;
            }
        }
        if (FindNextFile(hFile, &fd) == FALSE)
            break;
    }
    FindClose(hFile);
    return FALSE;
}

void CTrlFeView::OnItemexpanding(NMHDR* pNMHDR, LRESULT* pResult) 
{
    TCHAR szPath[MAX_PATH], szTemp[MAX_PATH];
    WIN32_FIND_DATA fd;
    TV_INSERTSTRUCT tvis;
    TV_ITEM tvi;
    CTreeCtrl& tc = GetTreeCtrl();
    HTREEITEM hParent, hChild, hItem;
    HANDLE hFile;
    LPTSTR lpszSrc, lpsz;
    BOOL bFoundDir;
    int nLevel, nDirs;
    NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    if (pNMTreeView->action == TVE_EXPAND)
    {
        hParent = pNMTreeView->itemNew.hItem;
        hChild = tc.GetChildItem(hParent);
        while (hChild)
        {
            tc.DeleteItem(hChild);
            hChild = tc.GetChildItem(hParent);
        }
        GetPathFromItem(hParent, szPath);
        memset(&tvis, 0, sizeof(TV_INSERTSTRUCT));
        tvis.hInsertAfter = TVI_SORT;
        tvis.item.mask = TVIF_TEXT|TVIF_CHILDREN;
        wsprintf(szTemp, "%s\\*.*", szPath);
        hFile = FindFirstFile(szTemp, &fd);
        if (hFile == INVALID_HANDLE_VALUE)
            return;
        nDirs = 0;
        while(1)
        {
            if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
            {
                if ((lstrcmp(fd.cFileName, ".") != 0) && (lstrcmp(fd.cFileName, "..") != 0))
                {
                    tvis.hParent = hParent;
                    tvis.item.pszText = fd.cFileName;
                    wsprintf(szTemp, "%s\\%s", szPath, fd.cFileName);
                    if (HasSubDirs(szTemp))
                        tvis.item.cChildren = 1;
                    else
                        tvis.item.cChildren = 0;
                    tc.InsertItem(&tvis);
                    nDirs++;
                }
            }
            if (FindNextFile(hFile, &fd) == FALSE)
                break;
        }
        FindClose(hFile);
        if (nDirs == 0)
        {
            memset(&tvi, 0, sizeof(TV_ITEM));
            tvi.hItem = hParent;
            tvi.mask = TVIF_CHILDREN;
            tvi.cChildren = 0;
            tc.SetItem(&tvi);
        }
    }
    else if (pNMTreeView->action == TVE_COLLAPSE)
    {
        hItem = pNMTreeView->itemNew.hItem;
        hParent = tc.GetSelectedItem();
        if (!hParent)
        {
            tc.SelectItem(hItem);
        }
        else if (hParent != hItem)
        {
            while (1)
            {
                hParent = tc.GetParentItem(hParent);
                if (!hParent)
                    break;
                if (hParent == hItem)
                {
                    tc.SelectItem(hParent);
                    break;
                }
            }
        }
        hParent = pNMTreeView->itemNew.hItem;
        tc.Expand(hParent, TVE_COLLAPSE);
        hChild = tc.GetChildItem(hParent);
        while (hChild)
        {
            tc.DeleteItem(hChild);
            hChild = tc.GetChildItem(hParent);
        }
    }
	*pResult = 0;
}

void CTrlFeView::OnSelchanging(NMHDR* pNMHDR, LRESULT* pResult) 
{
	TCHAR szPath[MAX_PATH];
    CTreeCtrl& tc = GetTreeCtrl();
    HTREEITEM hItem;
    LPTSTR lpszSrc, lpsz;
    NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
    CTrlFeDoc *pDoc = (CTrlFeDoc *)GetDocument();
    hItem = pNMTreeView->itemNew.hItem;
    GetPathFromItem(hItem, pDoc->m_szPath);
    pDoc->UpdateAllViews(this);
	*pResult = 0;
}
