//trldefs.h

#ifndef _TRLDEFS_INCLUDED_
#define _TRLDEFS_INCLUDED_

#define TRL_MAGIC ".trl"
#define TRL_VERSION 0

//error codes
#define TRL_OK                  0
#define TRL_OLDER_VERSION       1
#define TRL_NEWER_VERSION       2
#define TRL_WRONG_GAME_VERSION  3
#define TRL_ERROR           -1

typedef struct
{
    long o_textiles;
    long s_textiles;
    long o_rooms;
    long s_rooms;
    long o_floordata;
    long s_floordata;
    long o_items;
    long s_items;
} trl_directory_t;

typedef struct
{
    char magic[4]; //TRL_MAGIC
    long trlversion; //version of .trl file
    long gameversion; //version of game
    char baselevel[12];
    char levelname[256];
    //char author[256]?;
    trl_directory_t dir;
} trl_header_t;

#endif //_TRLDEFS_INCLUDED_
